#
# spec file for package exim (Version 4.22)
#
# Copyright (c) 2005 SUSE LINUX Products GmbH, Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments via http://www.suse.de/feedback/
#

# neededforbuild  db-devel openssl-devel tcpd x-devel-packages
# usedforbuild    aaa_base acl attr bash bind-utils bison bzip2 coreutils cpio cpp cvs cyrus-sasl db devs diffutils e2fsprogs file filesystem fillup findutils flex gawk gdbm-devel glibc glibc-devel glibc-locale gpm grep groff gzip info insserv kbd less libacl libattr libgcc libstdc++ libxcrypt m4 make man mktemp modutils ncurses ncurses-devel net-tools netcfg openldap2-client openssl pam pam-devel pam-modules patch permissions popt ps rcs readline sed sendmail shadow strace syslogd sysvinit tar texinfo timezone unzip util-linux vim zlib zlib-devel XFree86-devel XFree86-libs autoconf automake binutils cracklib db-devel fontconfig fontconfig-devel gcc gdbm gettext libtool openssl-devel perl rpm tcpd

Name:         exim
URL:          http://www.exim.org/
Conflicts:    sendmail sendmail-tls postfix
License:      GPL
Group:        Productivity/Networking/Email/Servers
Autoreqprov:  on
provides:     smtp_daemon
%if %suse_version > 800
Requires:     logrotate
PreReq:       %insserv_prereq %fillup_prereq /usr/sbin/useradd fileutils textutils
%endif
Version:      4.22
Release:      143
Summary:      The Exim mail transfer agent, a replacement for sendmail
BuildRoot:    %{_tmppath}/%{name}-%{version}-build
Source:       exim-%{version}.tar.bz2
Source1:      sysconfig.exim
Source2:      exim.logrotate
Source11:     exim.rc
Source12:     permissions.exim
Source20:     http://www.logic.univie.ac.at/~ametzler/debian/exim4manpages/exim4-manpages.tar.bz2
%define exiscan_version 4.22-10
Source30:     http://duncanthrax.net/exiscan/exiscan-acl-%{exiscan_version}.patch.bz2
Patch:        exim-4.12-tail.patch
Patch2:       exim-4.30-CAN-2004-0400.dif
Patch3:       exim-4.22-spa-secfix.dif
Patch4:       exim-4.43-illegal-ipv6.dif
%package -n eximon
Summary:      Eximon, an graphical frontend to administer Exim's mail queue
Group:        Productivity/Networking/Email/Servers

%description
Exim is a mail transport agent (MTA) developed at the University of
Cambridge for use on Unix systems connected to the Internet. It is
freely available under the terms of the GNU General Public Licence. In
style it is similar to Smail 3, but its facilities are more extensive,
and in particular it has options for verifying incoming sender and
recipient addresses, for refusing mail from specified hosts, networks,
or senders, and for controlling mail relaying.



Authors:
--------
    Philip Hazel <ph10@cus.cam.ac.uk>


%description -n eximon
This allows administrators to view the exim agent's mail queue and
logs, and perform a variety of actions on queued messages, such as
freezing, bouncing and thawing messages, and even editing body and
header of mails.



Authors:
--------
    Philip Hazel <ph10@cus.cam.ac.uk>

%prep
%setup -q
%patch
%patch2 -p1
bzcat %{S:30} | patch -p1
%patch3 -p1
%patch4 -p1
cat <<-EOF > Local/Makefile
	# see src/EDITME for comments.
	BIN_DIRECTORY=/usr/sbin
	CONFIGURE_FILE=/etc/exim/exim.conf
	EXIM_USER=mail
	EXIM_GROUP=mail
	SPOOL_DIRECTORY=/var/spool/exim
	
	ROUTER_ACCEPT=yes
	ROUTER_DNSLOOKUP=yes
	ROUTER_IPLITERAL=yes
	ROUTER_MANUALROUTE=yes
	ROUTER_QUERYPROGRAM=yes
	ROUTER_REDIRECT=yes
	# ROUTER_IPLOOKUP=yes
	TRANSPORT_APPENDFILE=yes
	TRANSPORT_AUTOREPLY=yes
	TRANSPORT_PIPE=yes
	TRANSPORT_SMTP=yes
	TRANSPORT_LMTP=yes
	SUPPORT_MAILDIR=yes
	# SUPPORT_MAILSTORE=yes
	# SUPPORT_MBX=yes
	LOOKUP_DBM=yes
	LOOKUP_LSEARCH=yes
	# LOOKUP_CDB=yes
	# LOOKUP_DNSDB=yes
	LOOKUP_DSEARCH=yes
	# LOOKUP_LDAP=yes
	# LOOKUP_MYSQL=yes
	# LOOKUP_NIS=yes
	# LOOKUP_NISPLUS=yes
	# LOOKUP_ORACLE=yes
	# LOOKUP_PASSWD=yes
	# LOOKUP_PGSQL=yes
	# LOOKUP_WHOSON=yes
	# LOOKUP_WILDLSEARCH=yes
	CYRUS_SASLAUTHD_SOCKET=/var/run/sasl2/mux
	# LDAP_LIB_TYPE=OPENLDAP1
	# LDAP_LIB_TYPE=OPENLDAP2
	# LDAP_LIB_TYPE=NETSCAPE
	# LDAP_LIB_TYPE=SOLARIS
	
	# LOOKUP_INCLUDE=-I /usr/local/ldap/include -I /usr/local/mysql/include -I /usr/local/pgsql/include
	# LOOKUP_LIBS=-L/usr/local/lib -lldap -llber -lmysqlclient -lpq
	
	EXIM_MONITOR=eximon.bin
	
	AUTH_CRAM_MD5=yes
	AUTH_PLAINTEXT=yes
	# AUTH_SPA=yes
	SUPPORT_TLS=yes
	TLS_LIBS=-lssl -lcrypto
	
	INFO_DIRECTORY=%{_infodir}
	LOG_FILE_PATH=/var/log/exim/%%s.log
	EXICYCLOG_MAX=10
	COMPRESS_COMMAND=/bin/gzip
	COMPRESS_SUFFIX=gz
	ZCAT_COMMAND=/usr/bin/zcat
	# SUPPORT_PAM=yes
	# You probably need to add -lpam to EXTRALIBS
	# RADIUS_CONFIG_FILE=/etc/radiusclient/radiusclient.conf
	# CYRUS_PWCHECK_SOCKET=/var/pwcheck/pwcheck
	# USE_TCP_WRAPPERS=yes
	
	NO_SYMLINK=yes
	CHOWN_COMMAND=/bin/chown
	CHGRP_COMMAND=/bin/chgrp
	MV_COMMAND=/bin/mv
	RM_COMMAND=/bin/rm
	PERL_COMMAND=/usr/bin/perl
	# APPENDFILE_MODE=0600
	# APPENDFILE_DIRECTORY_MODE=0700
	# APPENDFILE_LOCKFILE_MODE=0600
	# CONFIGURE_FILE_USE_NODE=yes
	# CONFIGURE_FILE_USE_EUID=yes
	# DELIVER_BUFFER_SIZE=8192
	# EXIMDB_DIRECTORY_MODE=0750
	# EXIMDB_MODE=0640
	# EXIMDB_LOCKFILE_MODE=0640
	# HEADER_MAXSIZE="(1024*1024)"
	# INPUT_DIRECTORY_MODE=0750
	# LOG_DIRECTORY_MODE=0750
	# LOG_MODE=0640
	# LOOKUP_TESTDB=yes
	MAKE_SHELL=/bin/bash
	# MAX_NAMED_LIST=16
	# MAXINTERFACES=250
	# MSGLOG_DIRECTORY_MODE=0750
	# PERL_CC=
	# PERL_CCOPTS=
	# PERL_LIBS=
	PID_FILE_PATH=/var/run/exim.pid
	# SPOOL_DIRECTORY_MODE=0750
	# SPOOL_MODE=0640
	SUPPORT_MOVE_FROZEN_MESSAGES=yes
	HAVE_IPV6=YES
	
	CFLAGS=$RPM_OPT_FLAGS -Wall -fno-strict-aliasing
	EXTRALIBS=-ldl -L/usr/X11R6/%{_lib}
EOF
touch Local/eximon.conf

%build
%if %suse_version <= 800
	/usr/sbin/useradd -o -g mail -u 8 -s /bin/false -c "Mailer daemon" -d /var/spool/clientmqueue mail 2> /dev/null || :
%endif
make 

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/etc/init.d
mkdir -p $RPM_BUILD_ROOT/etc/logrotate.d
mkdir -p $RPM_BUILD_ROOT/usr/{bin,sbin,lib}
mkdir -p $RPM_BUILD_ROOT/var/log/exim
mkdir -p $RPM_BUILD_ROOT/var/spool/mail/
mkdir -p $RPM_BUILD_ROOT/var/adm/fillup-templates
mkdir -p $RPM_BUILD_ROOT%{_mandir}/man8
mkdir -p $RPM_BUILD_ROOT/usr/X11R6/bin
make 	inst_dest=$RPM_BUILD_ROOT/usr/sbin \
	inst_conf=$RPM_BUILD_ROOT/etc/exim/exim.conf \
	inst_info=$RPM_BUILD_ROOT/%{_infodir} 	install
mv $RPM_BUILD_ROOT/usr/sbin/exim-%{version}* $RPM_BUILD_ROOT/usr/sbin/exim
mv $RPM_BUILD_ROOT/etc/exim/exim.conf src/configure.default # with all substitutions done
install -m 755 %{S:11} $RPM_BUILD_ROOT/etc/init.d/exim
# aka...
for i in \
	/usr/lib/sendmail \
	/usr/bin/runq \
	/usr/bin/rsmtp \
	/usr/bin/mailq \
	/usr/bin/newaliases
do
	ln -sf ../sbin/exim $RPM_BUILD_ROOT$i
done
ln -sf exim $RPM_BUILD_ROOT/usr/sbin/sendmail
ln -sv ../../etc/init.d/exim $RPM_BUILD_ROOT/usr/sbin/rcexim
mv $RPM_BUILD_ROOT/usr/sbin/eximon* $RPM_BUILD_ROOT/usr/X11R6/bin/
cp -p %{S:1} $RPM_BUILD_ROOT/var/adm/fillup-templates/sysconfig.exim
install -m 644 %{S:2} $RPM_BUILD_ROOT/etc/logrotate.d/exim
install -m 755 util/cramtest.pl $RPM_BUILD_ROOT/usr/bin/
 
# man pages
mv doc/exim.8 $RPM_BUILD_ROOT/%{_mandir}/man8/
pod2man --center=EXIM --section=8 $RPM_BUILD_ROOT/usr/sbin/eximstats > $RPM_BUILD_ROOT/%{_mandir}/man8/eximstats.8
tar xvjf %{S:20} 
cp -p exim4-manpages/* $RPM_BUILD_ROOT/%{_mandir}/man8/
for i in \
	sendmail \
	runq \
	rsmtp \
	mailq \
	newaliases
do 
	ln -sf exim.8.gz $RPM_BUILD_ROOT/%{_mandir}/man8/$i.8.gz
done
for i in \
	exim_dumpdb \
	exim_fixdb \
	exim_tidydb 
do 
	ln -sf exim_db.8.gz $RPM_BUILD_ROOT/%{_mandir}/man8/$i.8.gz
done
perl -pi -e 's%/usr/share/doc/exim4%/usr/share/doc/packages/exim%g' `find $RPM_BUILD_ROOT/%{_mandir}/man8 -name "*.8"`
 
gzip -9 doc/*.txt
install -o root -g root -m 0755 -d $RPM_BUILD_ROOT/etc/permissions.d
install -o root -g root -m 0644 $RPM_SOURCE_DIR/permissions.exim $RPM_BUILD_ROOT/etc/permissions.d/exim
%if %suse_version <= 800

%pre
	/usr/sbin/useradd -o -g mail -u 8 -s /bin/false -c "Mailer daemon" -d /var/spool/clientmqueue mail 2> /dev/null || :
%endif

%post
if ! test -s etc/exim/exim.conf; then 
	if test -s etc/exim.conf; then
		mv etc/exim.conf etc/exim/
		echo moving exim.conf to /etc/exim/ 
	else
		cp -p usr/share/doc/packages/exim/configure.default etc/exim/exim.conf 
		echo copying default config file to /etc/exim/exim.conf
	fi
fi
# create logfiles if missing
for i in var/log/exim/main.log var/log/exim/panic.log var/log/exim/reject.log; do
	if ! test -e $i; then touch $i; chown mail:mail $i; chmod 640 $i ; fi
done
%if %suse_version < 800
	echo "Updating /etc/rc.config..."
	bin/cat > var/adm/fillup-templates/rc.config.exim <<-EOF 
		#
		# Start the exim mail transfer agent? (yes|no)
		#
		START_EXIM=no
	EOF
	bin/fillup -q etc/rc.config var/adm/fillup-templates/rc.config.exim
	bin/rm var/adm/fillup-templates/rc.config.exim
	bin/fillup -q etc/rc.config var/adm/fillup-templates/sysconfig.exim
	sbin/insserv etc/init.d/exim
%else
	%{fillup_and_insserv exim}
%endif
exit 0
%if %suse_version > 820

%preun
%stop_on_removal exim
%endif

%postun
%if %suse_version > 820
%restart_on_update exim
%endif
%insserv_cleanup

%clean

%files
%defattr(-,root,root)
%doc doc/*
%doc src/configure.default
%doc build-Linux-*/convert4r{3,4}
%doc %{_mandir}/man8/*
/usr/sbin/exicyclog
/usr/sbin/exigrep
/usr/sbin/exiqgrep
/usr/sbin/exim
/usr/sbin/exim_*
/usr/sbin/eximstats
/usr/sbin/exinext
/usr/sbin/exiqsumm
/usr/sbin/exiwhat
%dir /etc/exim
%config /etc/init.d/exim
%config(noreplace) /etc/logrotate.d/exim
%config(noreplace) /etc/permissions.d/exim
/usr/sbin/rcexim
/usr/bin/mailq
/usr/bin/runq
/usr/bin/rsmtp
/usr/bin/newaliases
/usr/bin/cramtest.pl
/usr/sbin/sendmail
/usr/lib/sendmail
/var/adm/fillup-templates/sysconfig.exim
%dir /var/log/exim

%files -n eximon
%defattr(-,root,root)
/usr/X11R6/bin/eximon
/usr/X11R6/bin/eximon.bin

%changelog -n exim
* Wed Jan 12 2005 - poeml@suse.de
- security fixes:
- CAN-2005-0021 host_aton() Buffer Overflow Vulnerability
  [#49675]
- CAN-2005-0022 auth_spa_server() Buffer Overflow Vulnerability
  SPA support is not compiled in. Fix added nevertheless [#49676]
* Sun May 09 2004 - poeml@suse.de
- add patch against buffer overflow with header name when
  headers_check_syntax is enabled (CAN-2004-0400) [#40126]
  http://www.exim.org/pipermail/exim-users/Week-of-Mon-20040503/071126.html
* Mon Sep 08 2003 - poeml@suse.de
- exim.rc: delete <feedback@suse.de> address
* Tue Aug 26 2003 - poeml@suse.de
- don't remove empty log files in %%preun, since it's actually run
  after %%post in update mode [#29368]
* Mon Aug 18 2003 - poeml@suse.de
- update to 4.22, which fixes a few bugs in 4.21
- improve start section of init script. Don't start multiple
  processes; don't disrupt mail transfer
* Fri Aug 15 2003 - poeml@suse.de
- update to 4.21. many changes, see NewStuff and ChangeLog file!
- prevent possible overflow in HELO/EHLO command by
  (a) rewrite of the offending code in a cleaner fashion.
  (b) If an incoming SMTP command contains a NULL character, it
  is rejected as invalid.
- sieve support (rfc 3028)
- support for saslauthd authentication
- cramtest.pl utility updated
- eximstats 1.28 (addition of -nt option)
- If a DNS black list lookup found a CNAME record, but there were
  no A records associated with the domain it pointed at, Exim
  crashed.
- add new Auto-Submitted header on e.g. bounces
- new option syslog_duplication
- more flexible way to specify listening addresses/ports
- use -Wall
- add -fno-strict-aliasing, due to warnings about code where
  dereferencing type-punned pointers will break strict aliasing
- add activation metadata to sysconfig template [#28874]
- add patch for IPv6 breakage until 4.22 is out
- don't use startproc to start exim. It can't distinguish the
  parent daemon from queue runners or other children [#28082]
* Wed Jul 30 2003 - poeml@suse.de
- new macros for stop/restart of services on rpm update/removal
* Wed May 21 2003 - coolo@suse.de
- avoid empty %%pre
- avoid absolute symlinks below /usr
* Thu May 15 2003 - poeml@suse.de
- update to 4.20
- bug fixes
- upgraded to PCRE 4.2
- upgraded eximstats to 1.27
- added versioning to the local_scan() API
- Added acl_smtp_helo
- added the "discard" verb to ACLs.
- for building, DESTDIR can be used now instead of ROOT
- behaviour of -t in the presence of Resent- headers has been
  changed for compatibility
- added new syslog facilities:
  (i)  SYSLOG_LOGS_PID and LONG_SYSLOG_LINES in src/EDITME.
  (ii) syslog_facility and syslog_processname main options.
- the documentation was brought up to date.
- update exiscan patch to exiscan-acl-4.20-02
- remove filelist hack from %%clean, since now we have rpm4 :-)
- create logfiles from %%post, not in the init script [#24262]
* Tue Apr 22 2003 - poeml@suse.de
- update to 4.14. As always, there are lots of minor fixes and
  cleanups. New features include MySQL lookups over Unix domain
  sockets, the ability to en/disable parts of the configuration
  file with ".if", new options for fine-tuning the behavior with
  respect to unknown SMTP commands, announcing of AUTH and
  pipelining, and lots of new expansion operators.
- remove the obsolete (3.x style) %%s in pidfile name
- the eximstats utility contains an official manpage, so we can
  drop Andreas' version from the manpages tar ball
- add Tom Kistner's exiscan patch
- include the exiqgrep script
- improve the logrotate configuration, so the eximstats report is
  sent upon rotation (weekly), and not every night. Sending the
  report can be disabled by touching /var/log/exim/no_report_mail.
* Thu Apr 10 2003 - ro@suse.de
- fix deprecated tail call syntax (-1)
* Thu Feb 13 2003 - lmuelle@suse.de
- fix typo in sysconfig metadata
* Wed Feb 12 2003 - mmj@suse.de
- Add sysconfig metadata [#22641]
* Wed Dec 18 2002 - poeml@suse.de
- update to 4.12 (more bug fixes: lookup search bug, too many
  non-mail commands bug, and others)
- package the installed exim.conf as configure.default, since it
  has all substitutions done (since 4.11, SYSTEM_ALIASES_FILE is
  replaced at install time)
* Wed Dec 11 2002 - poeml@suse.de
- update to 4.11, with security and bug fixes. The more important
  changes are:
- [in short] Make exim cope with strace -f
- Make sure Exim doesn't overrun the buffer if an oversize packet
  is received from a nameserver.
- Exim crashed on an attempt to check senders or sender domains
  in an ACL other than after RCPT or DATA. It's now a temporary
  error.
- Minor security problem involving pid_file_path (admin user
  could get root) has been fixed.
- If an ACL that was read from a file was used in more than one
  message in a single SMTP transaction, Exim could crash or
  misbehave in arbitrary ways. [...]
- A similar problem to 127: memory corruption could occur for
  multiple messages in one SMTP connection if the data from DNS
  black list lookups was being used in log or user messages, e.g.
  references to $dnslists_text.
  For the complete list of changes, see
  ftp://ftp.csx.cam.ac.uk/pub/software/email/exim/ChangeLogs/
- remove rmail symlink as it conflicts with rmail from the uucp
  package
* Mon Nov 11 2002 - poeml@suse.de
- use #neededforbuild macro 'x-devel-packages' instead of xf86
- add man pages, provided by Andreas Metzler
- add some symlinks that exim might be called under
* Tue Aug 13 2002 - poeml@suse.de
- remove stupid arch-dependant path from filelist
* Tue Aug 13 2002 - poeml@suse.de
- mv exim.conf to /etc/exim/
- add scripts for conversion of 3.xx config files
- add symbolic link "runq" (same as exim -q)
- use %%defattr
* Mon Aug 12 2002 - poeml@suse.de
- improve logrotate configuration
- fix PreReq
- install exim.8 manpage and gzip the remaining documentation
- Moved log file creation from %%post to rcexim
* Tue Aug 06 2002 - draht@suse.de
- added /etc/permissions.d/exim for setuid /usr/sbin/exim
* Fri Aug 02 2002 - poeml@suse.de
- package created (4.10)
